package de.accso.flexinale.domain.model;

import de.accso.flexinale.shared_kernel.DoNotCheckInArchitectureTests;
import de.accso.flexinale.shared_kernel.EqualsByContent;
import de.accso.flexinale.shared_kernel.Identifiable;
import de.accso.flexinale.shared_kernel.Versionable;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

public class Ticket implements Identifiable, Versionable, EqualsByContent {

    public enum VerkaufsKanal {
        ONLINE,
        ZENTRAL,
        KINOKASSE
    }

    public final Id id;
    public final Version version;

    @DoNotCheckInArchitectureTests
    public final Film film;
    @DoNotCheckInArchitectureTests
    public final Vorfuehrung vorfuehrung;
    @DoNotCheckInArchitectureTests
    public final Besucher besucher;
    @DoNotCheckInArchitectureTests
    public VerkaufsKanal verkaufsKanal;

    public Ticket(final Id id,
                  final Film film, final Vorfuehrung vorfuehrung, final Besucher besucher,
                  final VerkaufsKanal verkaufsKanal) {
        this(id, Versionable.unknownVersion(), film, vorfuehrung, besucher,  verkaufsKanal);
    }

    public Ticket(final Id id, final Version version,
                  final Film film, final Vorfuehrung vorfuehrung, final Besucher besucher,
                  final VerkaufsKanal verkaufsKanal) {
        this.id = id;
        this.version = version;
        this.film = film;
        this.vorfuehrung = vorfuehrung;
        this.besucher = besucher;
        this.verkaufsKanal = verkaufsKanal;
    }

    @Override
    public Id id() {
        return id;
    }

    @Override
    public Version version() {
        return version;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(final Object o) {
        if (!equalsByContent(o)) return false;

        if (this == o) {return true;}
        if (o == null || getClass() != o.getClass()) {return false;}
        Ticket that = (Ticket) o;
        return new EqualsBuilder().append(version, that.version).isEquals();
    }

    @SuppressWarnings("DataFlowIssue")
    @Override
    public boolean equalsByContent(final Object o) {
        if (this == o) {return true;}

        if (o == null || getClass() != o.getClass()) {return false;}

        Ticket that = (Ticket) o;

        boolean result = new EqualsBuilder()
                .append(id, that.id)
                .append(verkaufsKanal, that.verkaufsKanal)
                .isEquals();
        if (!result) return false;

        if (film == null && that.film == null) result = true;
        if (film == null && that.film != null) return false;
        if (film != null) {
            result = film.equalsByContent(that.film);
            if (!result) return false;
        }

        if (vorfuehrung == null && that.vorfuehrung == null) result = true;
        if (vorfuehrung == null && that.vorfuehrung != null) return false;
        if (vorfuehrung != null) {
            result = vorfuehrung.equalsByContent(that.vorfuehrung);
            if (!result) return false;
        }

        if (besucher == null && that.besucher == null) result = true;
        if (besucher == null && that.besucher != null) return false;
        if (besucher != null) {
            result = besucher.equalsByContent(that.besucher);
        }

        return result;
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37)
                .append(id).append(version)
                .append(film).append(vorfuehrung).append(besucher)
                .append(verkaufsKanal)
                .toHashCode();
    }
}
